plugin simpleMeshMod Vu_Vibrator
	name:"Vu_Vibrator"
	classID:#(0xDDBF551, 0x3C208177)
	category:"Max Creation Graph"
(
	local pluginDefinitionFile -- the plugin definition file
	local pluginInstance -- the plugin instance created from the plugin definition
	local _meshWrapper -- the dotnet wrapper around the stack mesh pointer
	local argsType = dotNetClass "System.Object[]" -- used when creating args array
	local dotnet_ValueToDotNetObject = dotnet.ValueToDotNetObject
	local tmHandler

	-- function wrappers
	local _meshWrapper_SetValue
	local pluginInstance_UpdateMesh

	-- value wrapper local and function wrapper declarations
	local meshWrapper, meshWrapper_SetValue
	local helperWrapper, helperWrapper_SetValue
	local modifierTransformWrapper, modifierTransformWrapper_SetValue
	local boundingBoxWrapper, boundingBoxWrapper_SetValue


	parameters main rollout:params
	(
		UseMulti_IDs ui:UseMulti_IDs default:False type:#boolean animatable:true
		Normalize ui:Normalize default:False type:#boolean animatable:true
		helper ui:helper type:#node useNodeOsValidity:true useNodeTmValidity:true
		Legacy_Infl_ ui:Legacy_Infl_ default:0 type:#float animatable:true
		CosmicVibration ui:CosmicVibration default:0 type:#float animatable:true
		TimeWarp ui:TimeWarp default:1 type:#float animatable:true
		VibraFunc ui:VibraFunc default:0 type:#integer animatable:true
		Amplify ui:Amplify default:1 type:#float animatable:true
		Spin ui:Spin default:0 type:#float animatable:true
		RandomXPos ui:RandomXPos default:False type:#boolean animatable:true
		RandomYPos ui:RandomYPos default:False type:#boolean animatable:true
		RandomZPos ui:RandomZPos default:False type:#boolean animatable:true
		Distance ui:Distance default:0 type:#float animatable:true
		QuantumJump ui:QuantumJump default:False type:#boolean animatable:true
		CosmicRandomness ui:CosmicRandomness default:True type:#boolean animatable:true
		SeedLevels ui:SeedLevels default:13 type:#integer animatable:true
		MaxLevels ui:MaxLevels default:1 type:#integer animatable:true
		SeedDistance ui:SeedDistance default:13 type:#integer animatable:true
		MaxIDs ui:MaxIDs default:9 type:#integer animatable:true
		ManualVertColour ui:ManualVertColour default:False type:#boolean animatable:true
		RGB ui:RGB default:0 type:#integer animatable:true
		R ui:R default:0 type:#integer animatable:true
		G ui:G default:0 type:#integer animatable:true
		B ui:B default:0 type:#integer animatable:true
		_dummy type:#boolean -- this exists to enable easy invalidation of the object        
		pluginGraph type:#filename assettype:#MaxCreationGraph readOnly:true enumAsAsset:true 
        pluginGraphDependencies type:#filenametab assettype:#MaxCreationGraph readOnly:true enumAsAsset:true tabSize:0 tabSizeVariable:true
    ) 

rollout params "Parameters"
	(
		Group "Legacy Repel"
			(
			pickbutton helper "helper" autodisplay:true type:#node
			spinner Legacy_Infl_ "Legacy Infl." range:[-99, 10000, 0] type:#float
			checkbox Normalize "Normalize" checked:False
			)

		slider VibraFunc "VibraFunc" range:[0, 3, 0] type:#integer
		label lab11 "Sine : Wrap : Log10 :  LogN"
		label lab21 ""
		spinner CosmicVibration "CosmicVibration" range:[-9999, 9999, 0] type:#float
		spinner TimeWarp "TimeWarp" range:[0, 999, 1] type:#float
		spinner Amplify "Amplify" range:[-999, 999, 1] type:#float

		Group "Uncertainty"
			(
			checkbox  CosmicRandomness "Cosmic Randomness" checked:True

			spinner Spin "Spin" range:[0, 90, 0] type:#float

			spinner Distance "Distance" range:[-999, 999, 0] type:#float
			spinner SeedDistance "SeedDistance" range:[0, 9999, 13] type:#integer
			checkbox RandomXPos "RandomXPos" checked:False
			checkbox RandomYPos "RandomYPos" checked:False
			checkbox RandomZPos "RandomZPos" checked:False

			checkbox  QuantumJump "Quantum Jump" checked:False
			spinner MaxLevels "MaxLevels" range:[0, 100, 1] type:#integer
			spinner SeedLevels "SeedLevels" range:[0, 9999, 13] type:#integer
			)
		Group "Use MultiMat IDs"
			(
			checkbox UseMulti_IDs "Use Multi Mat IDs" checked:False
			spinner MaxIDs "Max IDs" range:[1, 999, 9] type:#integer
			)
		Group "Vertex Colour"
			(
			label lab31 "If this is ON, should turn" align:#left
			label lab32 "Multi Mat IDs OFF" align:#left

			checkbox VertexChDisplay "Vertex Ch Display" checked:False

			on params open do VertexChDisplay.state = $.showVertexColors
			on VertexChDisplay changed val do $.showVertexColors = not $.showVertexColors

			checkbox ManualVertColour "Manual Vert Colour" checked:False

			spinner R "R" range:[0, 255, 0] type:#integer
			spinner G "G" range:[0, 255, 0] type:#integer
			spinner B "B" range:[0, 255, 0] type:#integer
			spinner RGB "RGB as One" range:[0, 255, 0] type:#integer
			)
	)

rollout inforoll "About"
	(
		Group "Vu Vibrator Info"
		(
			label lab21 "Author: Vu Nguyen" align:#left
			label lab22 "(c) Vu Nguyen 2015" align:#left
			label lab24 "Version: 2.00.00" align:#left
			label lab25 "Email: vusta@hotmail.com" align:#left
		)

	)

	fn initialize = 
	(
		pluginDefinitionFile = @"C:/Users/Honey/Autodesk/3ds Max 2016/Max Creation Graph/Tools/Vu_Vibrator.maxtool"
		local c = dotNetClass "Viper3dsMaxBridge.ModifierPluginInstance"
		local cid = this.classId
		local refMakerWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.ReferenceMaker"
		refMakerWrapper = refMakerWrapperClass._CreateWrapper this
		pluginInstance = c.CreateInstance cid[1] cid[2] pluginDefinitionFile refMakerWrapper
		pluginInstance_UpdateMesh = pluginInstance.UpdateMesh
		local meshWrapperClass = dotnetclass "Autodesk.Max.MaxPlus.Mesh"
		_meshWrapper = meshWrapperClass._CreateWrapper undefined
		_meshWrapper_SetValue = _meshWrapper._SetValue
		pluginGraph = pluginDefinitionFile
		pluginGraphDependencies = #(@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\NodePositionOrBoxCenter.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\NodePositionInLocalSpace.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\NodeTMInLocalSpace.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\BoundingBoxCenter.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array4.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Array3.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\DeformMeshPoints.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\RandomVectorWithNeg.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\RandomChoice.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\RandomBoolean.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\PerFrameValueCache.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\ExtractCurrentValueFromCache.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\Remap.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\AndAlso3.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SetX.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SetY.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SetZ.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\PlusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\TransformMesh.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MinusOne.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\ColorVertices.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\MeshFaceVertices.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SelectByIndex.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\SetAverageVertexColorsAcrossSharedCorners.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\AverageAdjacentVertexColors.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\SelectByIndex.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\AverageVector.maxcompound",@"C:\Program Files\Autodesk\3ds Max 2016\MaxCreationGraph\Compounds\Sum.maxcompound",@"C:\Users\Honey\Autodesk\3ds Max 2016\Max Creation Graph\Compounds\MapVertexDataToFaceVertices.maxcompound")

		-- value wrapper local initializations
		local meshWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.Mesh"
		meshWrapper = meshWrapperClass._CreateWrapper (undefined)
		meshWrapper_SetValue = meshWrapper._SetValue
		local helperWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.INode"
		helperWrapper = helperWrapperClass._CreateWrapper (undefined)
		helperWrapper_SetValue = helperWrapper._SetValue
		local modifierTransformWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.Matrix3"
		modifierTransformWrapper = modifierTransformWrapperClass._CreateWrapper (matrix3 1)
		modifierTransformWrapper_SetValue = modifierTransformWrapper._SetValue
		local boundingBoxWrapperClass = dotNetClass "Autodesk.Max.MaxPlus.Box3"
		boundingBoxWrapper = boundingBoxWrapperClass._CreateWrapper (box3())
		boundingBoxWrapper_SetValue = boundingBoxWrapper._SetValue

	)

	fn updateMesh = 
	(
		if (tmHandler == undefined) then ( tmHandler = when transform owningNode changes do _dummy = not _dummy )
		if (pluginInstance == undefined) then ( return undefined )
		local args = dotnet_ValueToDotNetObject #(UseMulti_IDs, meshWrapper, Normalize, helperWrapper, modifierTransformWrapper, boundingBoxWrapper, Legacy_Infl_, CosmicVibration, TimeWarp, VibraFunc, Amplify, Spin, RandomXPos, RandomYPos, RandomZPos, Distance, QuantumJump, CosmicRandomness, SeedLevels, MaxLevels, SeedDistance, MaxIDs, ManualVertColour, RGB, R, G, B) argsType
		pluginInstance_UpdateMesh (currentTime as integer) _meshWrapper args
	)
	
	on modifyMesh do
	(
		try 
		(
			_meshWrapper_SetValue mesh
			helperWrapper_SetValue helper
			meshWrapper_SetValue mesh
			modifierTransformWrapper_SetValue owningNode.Transform
			boundingBoxWrapper_SetValue boundingBox

			updateMesh()
			_meshWrapper_SetValue undefined

		)
		catch()
		ok
	)

	on create do 
	(
		initialize()
	)

	on clone fromObj do 
	(
		initialize()
	)

	on load do 
	(
		initialize()
	)

	on update do 
	(
		initialize()
	)
)
